
# Open a text window for display.

set outputWindow [text .t -height 10 -width 90 \
     -font {courier 18 bold} -disable ]

pack $outputWindow

# Initialize the namelist with the names of users
#  that we know will be online (root, daemon, lp),
#  and add "UID" to cleverly remove the header 
#  from consideration.

set namelist "root daemon lp UID"

# Run who and read the input from the who command.

set infl [open "|who" ]

# The gets call will return -1 when it hits an EOF.
#  Read the lines, extract the user name,
#  and if the username isn't already in our list, add it.

 while {[gets $infl line] &gt;= 0} {
    set name [string range $line 0 [string wordend $line 0]]
    if {[string first $name $namelist] &lt; 0} {
        set namelist "$name $namelist"
    }
}

# close the file, we're done with it.
catch {close $infl}

# Invoke ps, and read the input.

set infl [open "|ps -elf"]

# This time, we'll use the eof command to check
#  for end of file.

while {![eof $infl]} {
    set len [gets $infl line]
    
    # extract the user id from the line of data.

    set id [string trim [string range $line 5 14]]
    
    # If the id is not in our namelist, we have a hit.
    # Get the pertinent data and update the window.
    if {[string first $id $namelist] &lt; 0} {
        set pid [string trim [string range $line 14 20]]
        set cmd [string trim [string range $line 83 end]]
        $outputWindow insert end  \
	    [format "%12s - %5d - %s\n" $id $pid $cmd]
    }
}

